/*
 * Copyright (c) 2002 pancake <pancake@phreaker.net>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * This file is included in WiStumbler2 package.
 *
 * $Id: guiabout.c,v 1.0 2003/11/15 15:54:29 pancake Exp $
 */

#ifdef USE_GTK

#include <gtk/gtk.h>
#include "guimenu.h"
#define ABOUT_MSG \
"WiStumbler2 - pancake@phreaker.net\n\n"\
"Fork of the original WiStumbler for NetBSD coded by iseki.\n\n"\
"http://www.nopcode.org/?t=wistumbler2\n"

gboolean about_isopen=FALSE;

void
wistumbler_gui_closeabout(void*v)
{
	about_isopen=FALSE;
}

void
wistumbler_gui_about(parent)
	GtkWidget *parent;
{
	GtkWidget *w,*msg;
	if (about_isopen==TRUE)
		return;
	about_isopen=TRUE;

    	w=gtk_window_new(GTK_WINDOW_TOPLEVEL); /* TODO parent */
	  gtk_window_set_position(GTK_WINDOW(w), GTK_WIN_POS_CENTER);
	  //gtk_widget_set_parent(w,parent);
    	  gtk_window_set_title(GTK_WINDOW(w), "About wistumbler2");
	  gtk_widget_set_usize(GTK_WIDGET(w), 300,150);
 	  gtk_signal_connect(GTK_OBJECT(w), "destroy",
        	GTK_SIGNAL_FUNC(wistumbler_gui_closeabout), NULL);
	msg=gtk_label_new(ABOUT_MSG);
	  gtk_widget_show(msg);
	  gtk_container_add(GTK_CONTAINER(w),msg);
	
	gtk_widget_show(w);
}
#endif
