/*
 * Copyright (c) 2002 pancake <pancake@phreaker.net>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * This file is included in WiStumbler2 package.
 *
 * $Id: guiabout.c,v 1.0 2003/11/15 15:54:29 pancake Exp $
 */

#ifdef USE_GTK

#include <gtk/gtk.h>
#include <strings.h>
#include <stdlib.h>
#include "guimenu.h"
#define ABOUT_MSG \
"WiStumbler2 - pancake@phreaker.net\n\n"\
"Fork of the original WiStumbler for NetBSD coded by iseki.\n\n"\
"http://www.nopcode.org/?t=wistumbler2\n"

extern int usex;
gboolean error_isopen=FALSE;
char *error_oldmsg=NULL;

void
wistumbler_gui_closeerror(void*v)
{
	error_isopen=FALSE;
}

void
wistumbler_gui_error(msg)
	char *msg;
{
	GtkWidget *w,*msg_label,*vbox,*ok_button;
	while(!gtk)sleep(1);

	if (!usex)return;
	if (error_isopen==TRUE)
		return;
	error_isopen=TRUE;

	/* Dont show two times the same error msg */
	if (error_oldmsg)
		if (!strcmp(error_oldmsg,msg))
			return;
	if (error_oldmsg)
		free(error_oldmsg);
	error_oldmsg=strdup(msg);
	/* -- */

    	w=gtk_window_new(GTK_WINDOW_TOPLEVEL); /* TODO parent */
	  gtk_window_set_position(GTK_WINDOW(w), GTK_WIN_POS_CENTER);
 	//  gtk_window_set_position(GTK_WINDOW(w), GTK_WIN_POS_CENTER_ON_PARENT);
	 // gtk_container_border_width(GTK_CONTAINER(w),5);
	  //gtk_widget_set_parent(w,parent);
    	  gtk_window_set_title(GTK_WINDOW(w), "Error");
	  gtk_widget_set_usize(GTK_WIDGET(w), 300,100);
 	  gtk_signal_connect(GTK_OBJECT(w), "destroy",
        	GTK_SIGNAL_FUNC(wistumbler_gui_closeerror), NULL);
	vbox=gtk_vbox_new(FALSE,5);
	  gtk_container_add(GTK_CONTAINER(w),vbox);
	  gtk_widget_show(vbox);
	msg_label=gtk_label_new(msg);
	  gtk_widget_show(msg_label);
	  gtk_container_add(GTK_CONTAINER(vbox),msg_label);
	ok_button=gtk_button_new_from_stock(GTK_STOCK_OK);
	  gtk_widget_show(ok_button);
	  gtk_container_add(GTK_CONTAINER(vbox),ok_button);
	  gtk_signal_connect_object(GTK_OBJECT(ok_button),"clicked",
		GTK_SIGNAL_FUNC(gtk_widget_destroy),(gpointer)w);
	
	gtk_widget_show(w);
}
#endif
