#ifdef USE_PCAP

#include <pcap.h>
#include <net/dlt.h>
#include <stdio.h>
extern char *iface1;
#define BUFSIZE 65540

void dissect(char *user,struct pcap_pkthdr *hdr,u_char *pkt)
{
	int i;
	printf("[%x] ",hdr->len);
	switch(pkt[14])
	{
	case 0x45: printf("eth "); break;
	case 0x00: printf("arp "); break;
	}
	switch(pkt[17])
	{
	case 0x54: printf("icmp "); break;
	}
	printf("\t");
	for(i=14;i<30;i++)
		printf("%0.2x",(unsigned char )pkt[i]);
	printf("\n");
}

void 
wistumbler_sniff()
{
	pcap_handler callback=(pcap_handler)&dissect;
	int datalink=0;
	struct bpf_program filter;
	char *filter_app="";
	pcap_t *pd; /* like fd but for pcap :) */
	bpf_u_int32 net,mask;
	struct pcap_pkthdr header;
	const u_char *packet;
	char errbuf[PCAP_ERRBUF_SIZE];
	errbuf[0]=0;

	//dev=pcap_lookupdev(errbuf);
	//printf("errbuf: %s\n",errbuf);
	if (iface1==NULL)
		return;

	pd=pcap_open_live(iface1,BUFSIZE,1,69,errbuf);
	if (!pd)
	{
		printf("NOT PERMS TO SNIFF\n");
		return;
	}
	pcap_set_datalink(pd,0);
	//datalink=pcap_datalink(pd);
	pcap_lookupnet(iface1,&net,&mask,errbuf);
	/* set filter rules */
	//pcap_compile(pd,&filter,filter_app,0,net);
	//pcap_setfilter(pd,&filter);
	pcap_loop(pd,-1,callback,NULL);
/* NOT WALK */
	while(1)
	{
	packet=pcap_next(pd,&header);
	if (!packet) continue;
	printf("[*] %d\n",header.len);
	write(2,packet,header.len);
	printf("--\n");
	}
	pcap_close(pd);
}

#endif
